package uk.ac.ic.wlgitbridge.application;

import org.eclipse.jetty.server.Request;
import org.eclipse.jetty.server.handler.AbstractHandler;
import uk.ac.ic.wlgitbridge.bridge.WriteLatexDataSource;
import uk.ac.ic.wlgitbridge.writelatex.api.request.push.UnexpectedPostbackException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.BufferedReader;
import java.io.IOException;

/**
 * Created by Winston on 16/11/14.
 */
public class SnapshotPushPostbackHandler extends AbstractHandler {

    private final WriteLatexDataSource writeLatexDataSource;

    public SnapshotPushPostbackHandler(WriteLatexDataSource writeLatexDataSource) {
        this.writeLatexDataSource = writeLatexDataSource;
    }

    @Override
    public void handle(String target, Request baseRequest, HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException {
//                System.out.println("handling");
//                System.out.println(request.getMethod());
//                response.setContentType("text/html;charset=utf-8");
//                response.setStatus(HttpServletResponse.SC_OK);
        if (request.getMethod().equals("POST") && request.getPathInfo().endsWith("postback")) {
            String contents = getContentsOfReader(request.getReader());
            String projectName = request.getRequestURI().split("/")[1];
            SnapshotPushPostbackContents postbackContents = new SnapshotPushPostbackContents(writeLatexDataSource, projectName, contents);
            try {
                postbackContents.processPostback();
            } catch (UnexpectedPostbackException e) {
                throw new ServletException();
            }
            baseRequest.setHandled(true);
        }
    }

    private static String getContentsOfReader(BufferedReader reader) throws IOException {
        StringBuilder sb = new StringBuilder();
        for (String line; (line = reader.readLine()) != null; ) {
            sb.append(line);
        }
        return sb.toString();
    }

}
